From lrust.lifetime Require Export primitive.
From lrust.lifetime Require Export faking.
From iris.algebra Require Import csum auth frac gmap agree gset.
From iris.proofmode Require Import tactics.
Set Default Proof Using "Type*".

Section borrow.
Context `{invG Σ, lftG Lat E0 Σ, LatBottom Lat}.
Implicit Types κ : lft.

Lemma raw_bor_create E κ P :
  ↑lftN ⊆ E → ⎡lft_ctx⎤ -∗ ▷ P ={E}=∗ raw_bor κ P ∗ ([†κ] ={E}=∗ ▷ P).
Proof.
  iIntros (HE) "#LFT HP". iInv mgmtN as (A I) "(>HA & >HI & Hinv)" "Hclose".
  iMod (ilft_create _ _ κ with "HA HI Hinv") as (A' I' Hκ) "(HA & HI & Hinv)".
  rewrite big_sepS_later (big_sepS_elem_of_acc _ _ κ) //.
  iDestruct "Hinv" as "[Hinv Hclose']". rewrite /lft_inv.
  iDestruct "Hinv" as (Vκ) "[>% [[Hinv >%]|[Hinv >%]]]"; last first.
  { rewrite -fupd_frame_r {1}/lft_inv_dead. iSplitR "HP"; [|by auto].
    iDestruct "Hinv" as (Pinh Vinh) "(>% & Hdead & Hcnt & Hinh)".
    iMod (raw_bor_fake with "[Hdead]") as "[Hdead Hbor]"; [solve_ndisj|by iNext|].
    iFrame. iMod ("Hclose" with "[-]"); [|done]. iExists _, _. iFrame.
    rewrite big_sepS_later /lft_inv. iApply "Hclose'". iNext. iExists _.
    iFrame "%". iRight. rewrite /lft_inv_dead. iFrame "∗%". iExists _, _. by iFrame. }
  rewrite {1}lft_inv_alive_unfold;
    iDestruct "Hinv" as (Pb Pi) "(Halive & Hvs & Hinh)".
  rewrite /lft_bor_alive; iDestruct "Halive" as (B) "[[HboxB  >HownB] HB]".
  iDestruct (monPred_in_intro with "HP") as (V) "[#HV HP]".
  set (P' := (monPred_in V → P)%I).
  iMod (lft_inh_extend _ _ P' with "Hinh")
    as "(Hinh & HIlookup & Hinh_close)"; first solve_ndisj.
  iMod (slice_insert_full _ _ true _ _ P' bot with "[HP] HboxB")
    as (γB) "(HBlookup & HsliceB & HboxB)"; first by solve_ndisj.
  { rewrite /P'. iNext. by iIntros "% _ <-". }
  rewrite lookup_fmap. iDestruct "HBlookup" as %HBlookup.
  rewrite -(fmap_insert bor_filled _ _ (Bor_in ∅)).
  iMod (own_bor_update with "HownB") as "[HB● HB◯]".
  { eapply auth_update_alloc,
      (alloc_singleton_local_update _ γB (Excl (Bor_in bot))); last done.
    rewrite lookup_fmap. case:(B !! γB) HBlookup; done. }
  rewrite -fmap_insert.
  iSpecialize ("Hclose'" with "[Hvs Hinh HboxB HB● HB]").
  { iNext. iExists _. iFrame "%". iLeft. rewrite lft_inv_alive_unfold /lft_inv.
    iExists (P' ∗ Pb)%I, (P' ∗ Pi)%I.
    iFrame "Hinh". rewrite -lft_vs_frame /lft_bor_alive. iFrame. iExists _.
    iFrame "HboxB HB●". rewrite big_sepM_insert /=; [|by destruct (B !! γB)].
    iFrame. auto with lat. }
  iMod ("Hclose" with "[HA HI Hclose']") as "_".
  { iExists _, _.  iFrame. by rewrite big_sepS_later /lft_inv. }
  iSplitL "HB◯ HsliceB".
  + rewrite /bor /raw_bor /idx_bor_own. iModIntro. iExists γB. iSplitL "HB◯".
    * iExists bot. iFrame.
      iDestruct (monPred_in_intro True%I with "[//]") as (V') "[H _]".
      by rewrite -(lat_bottom_sqsubseteq V').
    * iExists _. iIntros "{$HsliceB} !> !#". rewrite /P'.
      by iSplit; iIntros "H **"; iApply "H".
  + clear -HE. iIntros "!> H†".
    iInv mgmtN as (A I) "(>HA & >HI & Hinv)" "Hclose".
    iDestruct ("HIlookup" with "HI") as %Hκ.
    rewrite (big_sepS_elem_of_acc _ _ κ) //. iDestruct "Hinv" as "[Hinv Hclose']". 
    rewrite /lft_dead; iDestruct "H†" as (Λ V') "(% & #HV' & #H†)".
    iDestruct (own_alft_auth_agree A Λ (false, V') with "HA H†") as %EQAΛ.
    rewrite {1}/lft_inv; iDestruct "Hinv" as (Vκ) "[>HVκ [[_ >EQ]|[Hinv >%]]]".
    { unfold lft_alive_in. iDestruct "EQ" as %EQ. specialize (EQ Λ).
      rewrite <-leibniz_equiv_iff, EQAΛ in EQ. naive_solver. }
    iDestruct "HVκ" as %HVκ.
    rewrite /lft_inv_dead; iDestruct "Hinv" as (Pinh Vinh) "(>% & Hdead & >Hcnt & Hinh)".
    iMod ("Hinh_close" $! Vinh Pinh with "Hinh") as (Pinh') "(? & HP & ?)".
    iMod ("Hclose" with "[-HP]") as "_".
    * iExists A, I. iFrame. iNext. iApply "Hclose'". rewrite /lft_inv. iExists _.
      iFrame "%". iRight. iFrame "%". rewrite /lft_inv_dead. iExists Pinh', Vinh.
      by iFrame.
    * specialize (HVκ Λ). destruct (A !! Λ) as [[]|]; try by inversion EQAΛ.
      apply (inj Some), (inj2 pair) in EQAΛ. destruct EQAΛ. setoid_subst.
      rewrite (_:Vinh ⊑ V'); [|solve_lat]. iModIntro. iNext.
      by iApply (monPred_in_elim with "HV' HP").
Qed.

Lemma bor_create E κ P :
  ↑lftN ⊆ E → ⎡lft_ctx⎤ -∗ ▷ P ={E}=∗ &{κ}P ∗ ([†κ] ={E}=∗ ▷ P).
Proof.
  iIntros (?) "#LFT HP". iMod (raw_bor_create with "LFT HP") as "[HP $]"; [done|].
  rewrite /bor. iExists _. iFrame. iApply lft_incl_refl.
Qed.
End borrow.
