# RBrlx (RustBelt Relaxed) COQ DEVELOPMENT

This is the Coq development accompanying RBrlx. This version has been anonymized
for blind review.


## Structure

* The directories [stdpp/] and [iris-coq/] contain the external libraries needed
  for this development. They are not part of this contribution, thus are not
  anonymized.
* The directory [orc11/] contains the formalization of the ORC11 semantics.
* The directory [gpfsl/] contains the formalization of the GPFSL logic.
* The directory [RBrlx/] contains the formalization of RBrlx, including the
  lifetime logic, the type system, and the verifications of unsafe libraries.


## Prerequisites

This version is known to compile with:

 - Coq 8.7.2 / 8.8.0
 - A development version of [stdpp/]
 - A development version of [iris-coq/]

## Building Instructions

Below, `N` is the number of CPU cores you want to use.

1. Install the required version of Coq.
2. Go to the directory [stdpp/], run `make -jN` to build, then `make install` to
    install the `coq-stdpp` library.
3. Go to the directory [iris-coq/], run `make -jN` to build, then `make install`
    to install the `coq-iris` library.
4. Go to the directory [orc11/], run `make -jN` to build, then `make install` to
    install the relaxed memory semantics ORC11.
5. Go to the directory [gpfsl/], run `make -jN` to build, then `make install` to
    install the relaxed memory logic GPFSL.
5. Go to the directory [RBrlx/], run `make -jN` to build the main development of
    RBrlx. The directory provides an additional [README.md](RBrlx/README.md).

[stdpp/]: stdpp/
[iris-coq/]: iris-coq/
[orc11/]: orc11/
[gpfsl/]: gpfsl/
[RBrlx/]: RBrlx/
